<template>
  <!--pages/home/main.wxml-->
  <div class='home'>
    <v-top :list ="list"></v-top>
    <div class="content">
    <div class="name">
      <div class="left" @click="info">
        <span>{{name}}</span>
        <img :src="right" alt="">
      </div>
      <div class="right" @click="myright">
        <span>{{grade}} </span>
        <!-- <span>COLLECTO</span> -->
        <img :src="right" alt="">
      </div>
    </div>
    <!-- :style="{transform:num==='1'?'rotateY(180deg)':'rotateY(0deg)'}" v-if="show" class="limit"-->
    <!-- :style="{transform:num==='2'?'rotateY(180deg)':'rotateY(0deg)'}" v-if="!show" -->
    <div class="img" >
      <div   :class="{'limit':num==='1','limit1':num === '2'}" class="card card1" >
          <img :src="home" alt="" @click="rotate('1')"  >
      </div>
      <div :class="{'limit':num==='2','limit1':num === '1'}" class="card card2" >
         <img :src="bg1" alt="" @click="rotate('2')" >
         <div class="code" @click="rotate('2')">
          <div class="qrcode">
              <image bindtap="previewImg" mode="widthFix" :src="imagePath" style="width:70px;height:70px"></image>
              <canvas style="width:70px;height:70px;position: absolute;top: 0px;margin: 0rpx -9999px;" canvas-id="mycanvas" ></canvas>
          </div>
          <!-- <div class="barcode" >
            <image bindtap="previewImg" mode="widthFix" :src="imagePath1" style="width:120px;height:20px"></image>
              <canvas style="width:120px;height:20px;position: absolute;bottom: 0px;margin: 0rpx -9999px;" canvas-id="barcode" v-if="sec===120"></canvas>
          </div>  -->
      </div>
      <div class='cardno' >NO.{{card}}</div> 
      <div class='getcode' v-if="isGet == true" >{{sec}}秒后自动更新</div>
      </div> 
      
    </div>
    <div class="tip">点击卡片展示您的会员条码及二维码</div>
    <div   class="link" v-if="list1.length !==0">
       <swiper class="swiper"   vertical="true"   circular ="true" autoplay="true" interval="5000" duration="1000">
        <block v-for="(item, index) in list1" :index="index" :key="key">
          <swiper-item>
            <div @click="swipclick(index)" class="linktext">{{item.noticeMsg}}</div>
          </swiper-item>
        </block>
      </swiper>
    </div>
    
    <!-- 三列切换 -->
    <v-change :changelist="changelist"></v-change>

    </div>
    <!--弹出栏-->
    <v-hintbox :hintbox="hintbox" @close="close" ></v-hintbox>
  </div>
</template>
<script type="text/ecmascript-6">
  import config from '@/config'
  import top from '@/components/top/top.vue'
  import name from '@/components/name/name.vue'
  import change from '@/components/change/change.vue'
  import {VeevlinkLogin,VeevlinkIslogin,VeevlinkClient,VeevlinkData} from '@/utils/base'
  import {get,showToast,setStorageSync,getStorageSync,scanCode} from '@/util'
  import store from '@/store'
  import hintbox from '@/components/hintbox/hintbox.vue'
  import wxbarcode from 'wxbarcode'
  import qrcode from 'weapp-qrcode'
  let mta= require('@/utils/mta_analysis.js');
  import QR from '@/utils/qrCode.js'
  import barcode from '@/utils/barcode.js'
  import {mapMutations} from 'vuex';
  export default {
    data(){
      return{
        list1:[],
        time:'',
        list1rade:'',
        card:'',
        imagePath:'',
        imagePath1:'',
        right:config.url+'right.png',
        bg1:config.url+'card1.png',
        home:config.url+'home.png',
        isGet : false,
         sec : 60,
        cardno:'',
        animation1: null,//正面卡片动画
        animation2: null,//背面卡片动画
        name:'',
        show:true,
        num:'2',
        namelist:[
          {
            text:'左远方',
            type:'name',
          },
          {
            text:'藏家  COLLECTOR',
            type:'link',
          }
        ],
        changelist:[
          {
            name:"积分",
            data:[]
          },
          {
            name:"礼券",
            data:[]
          },
          {
            name:"服务",
            data:[]
          },

          ],
        list:[
          {
            type:'',
            couponId:'',
            activityId:'',
            noticeMsg:'',
            isRead:''
          }
        ],
        memberId:'',
        hintbox:{
          text :'',
          show : false
        },
        datas:{},
        
      }
    },
    components:{
      'v-hintbox' : hintbox,
      'v-top': top,
      'v-change': change,
      'v-name': name,
    },
    methods:{
      ...mapMutations(['SAVE_MEMBERINFO']),
      //点击图片触发事件
      swipclick(index) {
        let that = this;
        console.log('noticeindex',index);
        config.href(config.mainPage.notify);
        
      },
      //我的权益
      myright(){
        config.href(config.mainPage.myright);
      },
      //我的信息
      info(){
        config.href(config.mainPage.info+'?data=home')
      },
      // 验证码定时器
       getCode() {
         let  that = this;
         that.isGet =true;
         let num = 60;
         let sec = 60;
         that.time = setInterval(function () {
           if (num === 1) {
             clearInterval(that.time);
             that.sec = 60;
            //  that.isGet = true;
             that.getfresh();
             that.getCode();
             return false
           }else{
             num--;
             that.sec = num;
             sec = num;
             console.log('SEC',that.sec);
           }
           //  this.sec = remian;
         }, 1000);

       },
       //生成二维码
        createQrCode: function (canvasId, cavW, cavH) {
        let ct = Date.parse(new Date());
        let url = this.cardno;
        console.log('cardno', this.cardno)
        //调用插件中的draw方法，绘制二维码图片
        QR.api.draw(url, 'mycanvas', '70', '70');
        setTimeout(() => { this.canvasToTempImage(); }, 500);
      },
      canvasToTempImage: function () {
        var that = this;
        wx.canvasToTempFilePath({
            canvasId: 'mycanvas',
            success: function (res) {
                var tempFilePath = res.tempFilePath;
                console.log('生成临时图片路径。。。。',tempFilePath);
                that.imagePath = tempFilePath;
              },
              fail: function (res) {
                  console.log(res);
              }
        });
      },
        createQrCode1: function (canvasId, cavW, cavH) {
        let ct = Date.parse(new Date());
        let url = this.cardno;
        console.log('cardno', this.cardno)
        //调用插件中的draw方法，绘制二维码图片   
        barcode.code128(wx.createCanvasContext('barcode'), 'url', '120', '20');
        setTimeout(() => { this.canvasToTempImage1(); }, 500);
      },
      canvasToTempImage1: function () {
        var that = this;
        wx.canvasToTempFilePath({
            canvasId: 'barcode',
            success: function (res) {
                var tempFilePath = res.tempFilePath;
                console.log('生成临时图片路径1。。。。',tempFilePath);
                that.imagePath1 = tempFilePath;
              },
              fail: function (res) {
                  console.log(res);
              }
        });
      },

      //自动刷新
      autoRefresh: function() {
        let that = this;
        //let size = that.setCanvasSize();//动态设置画布大小
        that.createQrCode("mycanvas",'70', '70') //先生成一次
        //定义定时器
        // this.getCode();
        // that.data.setInter = setInterval(function () {
        //   console.log('定时一次', Date.parse(new Date()))
        //   that.createQrCode("mycanvas", size.w, size.h)
        // }, 5000);
      },
       //自动刷新
      autoRefresh1: function() {
        let that = this;
        //let size = that.setCanvasSize();//动态设置画布大小
        that.createQrCode1("qrcode",'120', '20') //先生成一次
        //定义定时器
        // this.getCode();
        // that.data.setInter = setInterval(function () {
        //   console.log('定时一次', Date.parse(new Date()))
        //   that.createQrCode("mycanvas", size.w, size.h)
        // }, 5000);
      },
      //卡片反转
      rotate(data){
        let that = this;
        that.num = data;
        if(that.num==='2'){
          that.sec = 60;
          clearInterval(that.time);
        }
        if(that.num==='1' && that.sec === 60){
      
            this.createQrCode();
            this.createQrCode1();
            this.getCode();
          
        }
        console.log('num',that.num);

      },
      //我的卡券
      link(){
        console.log('卡券跳转');
        config.href(config.mycard.card);
      },
      //我的信息
      myinfo(){
        console.log('我的信息跳转');
        
      },
      //商城跳转
      shop(){
        console.log('商城');
        config.href(config.shop.home);
      },
      //关闭弹窗
      close(){
        this.hintbox.show = false;
        this.hintbox.text = '';
      },
      //点击列表菜单
      menu(){
        console.log("列表菜单");
        config.href(config.activity.list);
      },
      getfresh(){
        let that = this;
        let VerificationCodeEntity =  wx.getStorageSync('informationwx23bcedfe9e867c13');
        let memberId = wx.getStorageSync('memberid');
        VeevlinkClient(
          '/member/qrCode/refresh?openId='+VerificationCodeEntity.OpenId + '&memberId='+memberId,
          'GET',
          '',
          function (data) {
            console.log(data);
            if(data.success){
              if(data.records[0]){
                
              }else{
                
              }
              
            }else{
              // that.hintbox.show = true;
              // that.hintbox.text = success.message;
              //let data = JSON.parse(data);
              var obj1 = JSON.parse(data); 
              that.cardno = obj1.message;
              console.log('json',obj1);
              
            }
          },
          function (error) {
            console.log(error);
          })
      },
      //首页接口
      getAjax(){
        let that = this;
        let VerificationCodeEntity =  wx.getStorageSync('informationwx23bcedfe9e867c13');
        let memberId = wx.getStorageSync('memberid');
        VeevlinkClient(
          '/member/homepage?openId='+VerificationCodeEntity.OpenId + '&memberId='+memberId,
          'GET',
          '',
          function (data) {
            console.log(data);
            if(data.success){
              if(data.records[0]){
                that.datas = data.records[0];
                that.SAVE_MEMBERINFO(that.datas.memberInfo)
                that.changelist[0].data = that.datas.memberInfo;
                that.changelist[1].data = that.datas.couponList; 
                that.changelist[2].data.push({
                  phone:that.datas.servicePhone
                });
                that.name = that.datas.memberInfo.memberName;
                that.grade = that.datas.memberInfo.grade;
                that.list = that.datas.expirationNoticeList;
                wx.setStorageSync('list',that.list);
                that.cardno = that.datas.memberInfo.cardNo;
                let card = that.datas.memberInfo.cardNo;
                if(card.length ===9){
                  that.card = card.substring(0,3) + ' '+card.substring(3,6)+' '+card.substring(6,9);
                }
                 if(card.length ===7){
                    that.card = card.substring(0,3) + ' '+card.substring(3,7);

                }
                console.log('listhome',that.list);
                that.datas.expirationNoticeList.forEach((item,index)=>{
                  if(!item.isRead){
                      that.list1.push({
                        type:item.type,
                        couponId:item.couponId,
                        activityId:item.activityId,
                        noticeMsg:item.noticeMsg
                      })
                  }
                  
                })
                console.log('test', that.list1);
              }else{
                
              }
              
            }else{
              that.hintbox.show = true;
              that.hintbox.text = success.message;
            }
          },
          function (error) {
            console.log(error);
          })
      }
    },
    //页面加载时，判断用户是否登录
    onLoad(data) {
      let that = this;
      mta.Page.init();
      this.getAjax();
      //this.getfresh();
    }
  }
</script>
<style lang="scss"  type="text/scss" scoped>
  /* pages/home/main.wxss */
  .home{
    background: #fff;
    swiper{
      height:20px;
    }
    .content{
      position: relative;
      top: 0.82rem;
      padding-top: 0.4rem;
      background: #fff;
      .name{
      display: flex;
      .left{
        display: flex;
        margin-left: 0.6rem;
        img{
          width: 0.12rem;
          height: 0.16rem;
          margin-left: 0.16rem;
          margin-top: 0.1rem;
        }
      }
      .right{
        display: flex;
        // margin-left: 2.51rem;
        position:absolute;
        right:0.5rem;
        img{
          width: 0.12rem;
          height: 0.16rem;
          margin-left: 0.16rem;
          margin-top: 0.1rem;
          
        }
        
      }
    }
    .img {
      margin-top: 0.54rem;
      height:3.5rem;
      .limit{
           transform:rotateY(180deg);
           transition:all 1s linear;
           backface-visibility: hidden;
      }
      .limit1{
           transform:rotateY(0deg);
           transition:all 1s linear;
           z-index:1000;
           backface-visibility: hidden;
      }
      .card{
        position:absolute;
        top:1.24rem;
        img{
        width: 6.66rem;
        height:3.53rem;
        margin-left: 0.42rem;
      }
      .card{
        transform: rotateY(0deg); 
      }
      .card2{
        transform: rotateY(180deg); 
      }
      }
      .code{
        width: 130px;
        position: absolute;
        top: 1.48rem;
        right: 0px;
        z-index:1000;
        
        .qrcode{
          margin-left:0.9rem;
          width: 70rpx;
          height: 70px;
        }
        .barcode{
           margin-top: 50px;
        }
      }
      .getcode{
        right: 0.4rem;
        font-size: 0.16rem;
        color: #727171;
        position: absolute;
        margin-top:-0.6rem;

      }
      .cardno {
        color:#595757;
        font-size:0.24rem;
        position:absolute;
        left:0.9rem;
        margin-top:-0.65rem;

      } 
    }
    .tip{
        color: #727171;
        font-size: 0.22rem;
        text-align: center;
        margin-top: 0.18rem;
      }
    .link{
      margin-top: 0.62rem;
      text-decoration-line: underline;
      color: #E7762E;
      text-decoration-color: #E7762E;
      text-align: center;
      font-size: 0.24rem;
      .linktext{
      //margin-top: 0.62rem;
      text-decoration-line: underline;
      color: #E7762E;
      text-decoration-color: #E7762E;
      text-align: center;
      font-size: 0.24rem;
    }
    }
    

    }
    
  }
 
</style>
